package cn.chmlfrp.chmlfrpplugin.app;

import cn.chmlfrp.chmlfrpplugin.GlobalVariables;
import cn.chmlfrp.chmlfrpplugin.entity.FrpcOutLog;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

/* loaded from: StartFrpc.class */
public class StartFrpc {
    public static void startFrpc(String token, String tunnelID) {
        Thread startFrpcThread = new Thread(() -> {
            ApiRequestThread apiRequestThread = new ApiRequestThread();
            String tunnelName = apiRequestThread.sendGetRequest("https://cf-v1.uapis.cn/api/tunnelinfo.php?id=" + tunnelID).getString("tunnel_name");
            String command = "cmd /c \".\\plugins\\ChmlFrpPlugin\\" + tunnelName + ".exe\" -u " + token + " -p " + tunnelID;
            if (GlobalVariables.osName.equals("Linux")) {
                command = "./plugins/ChmlFrpPlugin/" + tunnelName + " -u " + token + " -p " + tunnelID;
            }
            try {
                Process process = Runtime.getRuntime().exec(command);
                BufferedReader reader = new BufferedReader(new InputStreamReader(process.getInputStream(), "UTF-8"));
                StringBuilder output = new StringBuilder();
                GlobalVariables.frpcLogOut = new FrpcOutLog[]{new FrpcOutLog(tunnelID, "")};
                while (true) {
                    String line = reader.readLine();
                    if (line != null) {
                        output.append(line).append(System.lineSeparator());
                        GlobalVariables.frpcLogOut[GlobalVariables.frpcLogOut.length - 1].setLog(output.toString());
                    } else {
                        process.waitFor();
                        reader.close();
                        return;
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        });
        startFrpcThread.start();
    }

    public static void stopFrpc(String tunnelID) {
        Thread stopFrpcThread = new Thread(() -> {
            ApiRequestThread apiRequestThread = new ApiRequestThread();
            String tunnelName = apiRequestThread.sendGetRequest("https://cf-v1.uapis.cn/api/tunnelinfo.php?id=" + tunnelID).getString("tunnel_name");
            try {
                String command = "taskkill -F /IM " + tunnelName + ".exe";
                if (GlobalVariables.osName.equals("Linux")) {
                    command = "killall " + tunnelName;
                }
                Process process = Runtime.getRuntime().exec(command);
                process.getInputStream().close();
                process.getErrorStream().close();
                process.waitFor();
                String directoryPath = ".\\plugins\\ChmlFrpPlugin";
                if (GlobalVariables.osName.equals("Linux")) {
                    directoryPath = "./plugins/ChmlFrpPlugin";
                }
                String fileNameToDelete = tunnelName + ".exe";
                File directory = new File(directoryPath);
                File[] files = directory.listFiles();
                if (files != null) {
                    List<File> fileList = Arrays.asList(files);
                    boolean fileDeleted = false;
                    Iterator<File> it = fileList.iterator();
                    while (true) {
                        if (!it.hasNext()) {
                            break;
                        }
                        File file = it.next();
                        if (file.getName().equals(fileNameToDelete)) {
                            file.delete();
                            fileDeleted = true;
                            break;
                        }
                    }
                    if (!fileDeleted) {
                        GlobalVariables.chmlFrpPlugin.getLogger().info(TimeAndChatName.getTimeAndChatNameNoRgb() + "没有找到文件 " + fileNameToDelete);
                    }
                } else {
                    GlobalVariables.chmlFrpPlugin.getLogger().info(TimeAndChatName.getTimeAndChatNameNoRgb() + "目录不存在或无法访问。");
                }
            } catch (IOException | InterruptedException e) {
                e.printStackTrace();
            }
        });
        stopFrpcThread.start();
    }
}
